#include<bits/stdc++.h>
#define xx first
#define yy second
#define pb push_back

using namespace std;
typedef long long ll;

int n, q, cnt[30];
bool b[30][100010];
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for(int i=0; i<n; i++) {
        int y; cin >> y;
        for(int j=0; j<30; j++) {
            if(y==0) break;
            b[j][i]=y%2;
            if(b[j][i]) cnt[j]++;
            y/=2;
        }
    }
    cin >> q;
    while(q--) {
        int t, k; cin >> t >> k;
        k--;
        if(t==0) {
            int baza=1, suma=0;
            for(int j=0; j<30; j++) {
                suma+=baza*(cnt[j]>=k+1);
                baza*=2;
            }
            cout << suma << endl;
        }
        else {
            int x; cin >> x;
            for(int j=0; j<30; j++) {
                bool novo=x%2;
                if(b[j][k] && novo==0) {cnt[j]--; b[j][k]=0;}
                if(!b[j][k] && novo==1) {cnt[j]++; b[j][k]=1;}
                x/=2;
            }
        }
    }
    return 0;
}